/*
 * Large Assignment 1:Part 2: L-Systems
 * Name:    Raneem Ramadan
 * E-mail:  rramadan@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    9/13/2023
 *
 * This program will draw a tree with flowers structure using L-system rules.
*/

class LsystemClass{
  String axiom = "X";
                      
   String [][] rules = {{"F","FF"},
                       {"X","F[+X][-X]FX"},
                       {"+","+",},
                       {"-","-"},
                       {"[","["},
                       {"]","]"}}; 
                     
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  
  LsystemClass(float size, float angle, float scaleFactor){
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
    computedWord = axiom; 
    iterations = 0;
  }
  
  void iterate(int number){
  for(int i = 0; i < number; i++){
    iteration();
  }
}
  
  void iteration(){
    char s;
    String newWord = "";
    size = size*scaleFactor;
    // loop through computedWord
    for(int i = 0; i < computedWord.length(); i++){
       // for every symbol, check if a rule applies
       s = computedWord.charAt(i);
       // loop through rules to find a match
      for(int j = 0; j < rules.length; j++){
        if(s == rules[j][0].charAt(0)){
         newWord = newWord + rules[j][1]; // replacement 
          break;
        }
      }
    }
    iterations++;
    computedWord = newWord;
    println(iterations + ":" + computedWord);
  }
  
  void drawLSystem(Turtle t){ //draw 3 different systems
    //loop through computedWord and draw each symbol
    char s;
    for(int i = 0; i < computedWord.length(); i++){   
    s = computedWord.charAt(i);
    if (s == 'F'){     
      t.forward(size);
      
    }
    else if (s == '+'){
      t.right(angle);
      fill (#47B465);
      ellipse(t.getX(),t.getY(), 2,10);
    }
    else if(s == '-'){
       t.left(angle);
       fill (#47B465);
      ellipse(t.getX(),t.getY(), 2,10);
    }
    else if(s == '['){
      t.push();
      fill (#47B465);
      ellipse(t.getX(),t.getY(), 2,10);
    }
    else if(s == ']'){
      t.pop();
      fill (#47B465);
      ellipse(t.getX(),t.getY(), 2,10);
    }
    else if(s =='X'){
      fill (#D8E877);
      ellipse(t.getX(),t.getY(), 5,5);
      }
    }
  }
}