/*
 * Large Assignment 1:Part 2: L-Systems
 * Name:    Raneem Ramadan
 * E-mail:  rramadan@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    9/13/2023
 *
 * This program will draw a pine cone plant structure using L-system rules.
*/

class LsystemClass{
  String axiom = "Y";
                      
   String [][] rules = {{"X","FX[+FFF][-FFF]X"},
                       {"Y","[-Y][+Y]XFY"},
                       {"+","+"},
                       {"-","-"},
                       {"[","["},
                       {"]","]"}};  
                                     
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  
  LsystemClass(float size, float angle, float scaleFactor){
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
    computedWord = axiom; 
    iterations = 0;
  }
  
  void iterate(int number){
  for(int i = 0; i < number; i++){
    iteration();
  }
}
  
  void iteration(){
    char s;
    String newWord = "";
    size = size*scaleFactor;
    // loop through computedWord
    for(int i = 0; i < computedWord.length(); i++){
       // for every symbol, check if a rule applies
       s = computedWord.charAt(i);
       // loop through rules to find a match
      for(int j = 0; j < rules.length; j++){
        if(s == rules[j][0].charAt(0)){
         newWord = newWord + rules[j][1]; // replacement 
         break;
        }
      }
    }
    iterations++;
    computedWord = newWord;
    println(iterations + ":" + computedWord);
  }
  
  void drawLSystem(Turtle t){
    //loop through computedWord and draw each symbol
    char s;
    for(int i = 0; i < computedWord.length(); i++){   
    s = computedWord.charAt(i);
    if (s == 'F'){
    
      t.forward(size);
      t.push();
      t.left(60);
      t.forward(size*2);
      t.pop();
      t.push();
      t.right(60);
      t.forward(size*2);
      t.pop();
      fill (#6A3A0E);
      ellipse(t.getX(),t.getY(), 4,9);
    }
    else if (s == '+'){
      t.right(angle);
    }
    else if(s == '-'){  
      t.left(angle);
    }
    else if(s == '[')
      t.push();
    else if(s == ']')
      t.pop();
      else if(s =='Y'){
      fill (#6A3A0E);
      noFill();
      }
    else if(s =='X'){
      fill (#6A3A0E);
      noFill();
      }
  }
  }
}